%global python_version %(%{__python} -c "import sys; print sys.version[:3]" || echo 0)
%{!?python_sitelib: %global python_sitelib %{_prefix}/lib/python%{python_version}/site-packages}

Summary:	MoinMoin is a WikiEngine to collaborate on easily editable web pages
Name:		moin
Version:	1.8.8
Release:	1.0.cf%{?dist}
License:	GPLv2+
Group:		Applications/Internet
URL:		http://moinmo.in/
Source0:	http://static.moinmo.in/files/moin-%{version}%{?beta:%{beta}}.tar.gz
Source1:	README-rpm
Source2:	moin.init
Source3:	moin.sysconfig
Source4:	README.fastcgi
Patch100:	moin-1.8.5-email-links.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	python-devel >= 2.3, symlinks
%if "%{python_version}" == "2.3"
Requires:	python-abi = 2.3
%endif
Requires:	words

%description
MoinMoin is an advanced, easy to use and extensible WikiEngine with a large
community of users. Said in a few words, it is about collaboration on easily
editable web pages.

%prep
%setup -q -n moin-%{version}%{?beta:%{beta}}

# Better email notifications
%patch100 -p1

# FastCGI docs and support files
%{__mkdir} fastcgi
%{__cp} -p %{SOURCE2} %{SOURCE3} %{SOURCE4} fastcgi
%{__chmod} +x fastcgi/moin.init

# Fix missing exec permissions on files with valid shellbangs to silence rpmlint
%{__chmod} +x \
	'wiki/htdocs/applets/FCKeditor/editor/dialog/fck_spellerpages/spellerpages/server-scripts/spellchecker.pl' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/config.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/perl/connector.cgi' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/perl/upload.cgi' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/connector.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckcommands.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckconnector.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckoutput.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckutil.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/upload.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/wsgi.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/zope.py' \
	'wiki/server/test.wsgi' \
	'wiki/underlay/pages/HelpOnInstalling(2f)ApacheOnLinuxFtp/attachments/explore.py' \
	'wiki/underlay/pages/HelpOnInstalling(2f)BasicInstallation/attachments/pythontest.cgi' \
	'wiki/underlay/pages/HelpOnInstalling(2f)TroubleShooting/attachments/is_python_here.sh' \
	'wiki/underlay/pages/HelpOnInstalling(2f)TwistedWeb/attachments/servicerunner.py' \
	'wiki/underlay/pages/HelpOnInstalling(2f)WikiInstanceCreation/attachments/createinstance.sh'

# Fix line endings
%{__sed} -i -e 's|\r$||' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/config.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/connector.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckcommands.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckconnector.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckoutput.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/fckutil.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/upload.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/wsgi.py' \
	'wiki/htdocs/applets/FCKeditor/editor/filemanager/connectors/py/zope.py' \
	'wiki/underlay/pages/HelpOnInstalling(2f)TwistedWeb/attachments/servicerunner.py'

# Remove spurious shellbangs
/usr/bin/find MoinMoin jabberbot -name '*.py' | /usr/bin/xargs \
	%{__sed} -i	-e '/^#! *\/usr\/bin\/env python/d' \
			-e '/^#! *\/usr\/bin\/python/d'

# Kludge to remove bogus local perl dependencies from FCKeditor
%global reqfilt /bin/sh -c "%{__perl_requires} | %{__grep} -Evx 'perl[(][a-z_0-9]*\\.pl[)]'"
%define __perl_requires %{reqfilt}

%build
%{__python} setup.py build

%install
%{__rm} -rf %{buildroot}
%{__python} setup.py install -O1 --skip-build --root=%{buildroot}
%{__cp} -a %{SOURCE1} README-rpm

# Install link for spellcheck dictionary
%{__mkdir_p} %{buildroot}{%{_datadir}/dict,%{python_sitelib}/MoinMoin/dict}
/bin/touch %{buildroot}%{_datadir}/dict/words
%{__ln_s} %{buildroot}%{_datadir}/dict/words %{buildroot}%{python_sitelib}/MoinMoin/dict/words
/usr/bin/symlinks -cs %{buildroot}%{python_sitelib}/MoinMoin/dict
%{__rm} %{buildroot}%{_datadir}/dict/words
# Create directory for theme translations
%{__install} -d -m 755 %{buildroot}%{python_sitelib}/MoinMoin/i18n/themes

# Create directory for static content (forward compat with moin 1.9.0)
%{__install} -d -m 755 %{buildroot}%{python_sitelib}/MoinMoin/web/static/htdocs

# See if there's any egg-info
if [ -f %{buildroot}%{python_sitelib}/moin-%{version}-py%{python_version}.egg-info ]; then
	echo %{python_sitelib}/moin-%{version}-py%{python_version}.egg-info
fi > egg-info

%clean
%{__rm} -rf %{buildroot}

%files -f egg-info
%defattr(-,root,root,-)
%doc README README-rpm docs/CHANGES* docs/INSTALL.html docs/README.migration
%doc docs/licenses/
%doc fastcgi/
%{_bindir}/moin
%{_datadir}/moin/
%{python_sitelib}/MoinMoin/
%{python_sitelib}/jabberbot/

%changelog
* Mon Jun 14 2010 Paul Howarth <paul@city-fan.org> 1.8.8-1.0.cf
- Update to 1.8.8
  - Fixed XSS issues (see MoinMoinBugs/1.9.2UnescapedInputForThemeAddMsg).
  - Fixed XSS in Despam action (CVE-2010-0828).
  - wikiutil.clean_input: avoid crash if it gets str type
  - Add RenderAsDocbook to actions_excluded if we have no python-xml
  - AttachFile._build_filelist: verifies readonly flag for unzip file link
  - attachUrl: fix wrongly generated tickets (e.g. for AttachList macro)
  - Disable usage of dircache, deprecate dc* functions
  - Remove all calls to filesys.dc* (dclistdir, dcdisable)
  - Fixed crash, see MoinMoinPatch/IncludeMacroWithDocBookFormatter
  - Avoid hardly recoverable crashes if #format specification is invalid
  - Fixed info action: AttachFile sub-actions that needed a ticket did not work
  - auth.ldap_login: add report_invalid_credentials parameter
- Drop upstreamed patch for CVE-2010-0828

* Mon Apr  5 2010 Paul Howarth <paul@city-fan.org> 1.8.7-2.0.cf
- Fix XSS bug in Despam action (CVE-2010-0828, #578801)

* Tue Feb 16 2010 Paul Howarth <paul@city-fan.org> 1.8.7-1.0.cf
- Update to 1.8.7 (fix major security issues in various parts of moin)

* Mon Dec  7 2009 Paul Howarth <paul@city-fan.org> 1.8.6-1.0.cf
- Update to 1.8.6
- Fix a bunch of rpmlint warnings relating to scripts and permissions
- Include directory for static content (forward compat with moin 1.9.0)
- Remove question mark smiley <?>, dropped by Solenoid theme

* Fri Oct 30 2009 Paul Howarth <paul@city-fan.org> 1.8.5-2.0.cf
- Include directory for theme translations (used by Solenoid theme)
- Add question mark smiley <?> for use by Solenoid theme

* Tue Sep  8 2009 Paul Howarth <paul@city-fan.org> 1.8.5-1.0.cf
- Update to 1.8.5
- Make %%files list more explicit
- Restore filemanager directory in FCKeditor; bundled version now 2.6.4.1
- Add patch to include link to updated page in notification emails

* Tue Jul 28 2009 Paul Howarth <paul@city-fan.org> 1.8.4-3.0.cf
- Remove the filemanager directory from the embedded FCKeditor; it contains
  code with know security vulnerabilities, even though that code couldn't be
  invoked when moin was used with the default settings (#509924, CVE-2009-2265)

* Wed Jun 10 2009 Paul Howarth <paul@city-fan.org> 1.8.4-1.0.cf
- Update to 1.8.4 (fixes for hierarchical ACLs and MSIE8)

* Wed Apr 29 2009 Paul Howarth <paul@city-fan.org> 1.8.3-1.0.cf
- Update to 1.8.3

* Mon Feb  9 2009 Paul Howarth <paul@city-fan.org> 1.8.2-1.0.cf
- Update to 1.8.2

* Mon Jan 29 2009 Paul Howarth <paul@city-fan.org> 1.8.1-1.0.cf
- Update to 1.8.1

* Wed Nov  5 2008 Paul Howarth <paul@city-fan.org> 1.8.0-1.0.cf
- Update to 1.8.0

* Wed Sep 10 2008 Paul Howarth <paul@city-fan.org> 1.7.2-1.0.cf
- Update to 1.7.2

* Mon Jul 21 2008 Paul Howarth <paul@city-fan.org> 1.7.1-1.0.cf
- Update to 1.7.1
- Fix python_version macro definition to return 0 rather than %%{nil} if python
  is not in the buildroot

* Sun Jun 22 2008 Paul Howarth <paul@city-fan.org> 1.7.0-1.0.cf
- Update to 1.7.0

* Mon Apr 21 2008 Paul Howarth <paul@city-fan.org> 1.6.3-1.0.cf
- Update to 1.6.3

* Tue Mar 25 2008 Paul Howarth <paul@city-fan.org> 1.6.2-1.0.cf
- Update to 1.6.2

* Mon Feb  4 2008 Paul Howarth <paul@city-fan.org> 1.6.1-1.0.cf
- Update to 1.6.1

* Thu Jan 31 2008 Paul Howarth <paul@city-fan.org> 1.6.0-1.0.cf
- Update to 1.6.0
- Update source URL to use upstream's "home" site rather than sourceforge
- Update %%summary and %%description as per Fedora package
- Drop the config patch
- Tweak %%files list to pick up egg info file when present

* Mon Nov  5 2007 Paul Howarth <paul@city-fan.org> 1.6.0-0.beta1.1.CF
- Update to 1.6.0beta1
- New upstream URL is http://moinmo.in/
- Clarify license as GPL version 2 or later
- Update config patch
- Remove other patches, no longer applicable

* Mon May 14 2007 Paul Howarth <paul@city-fan.org> 1.5.8-1.CF
- Update to 1.5.8
- Changed download URL from dl.sf.net to downloads.sf.net
- Removed three security patches, now included upstream

* Wed May  9 2007 Matthias Saou <http://freshrpms.net/> 1.5.7-2.CF
- Remove obsolete for moin-fastcgi; nobody should need that any more

* Mon May  7 2007 Matthias Saou <http://freshrpms.net/> 1.5.7-2
- Include security fixes from the Debian package (Jonas Smedegaard)
- FIX_use_ACL_in_include_directive (Alexander Schremmer)
- fix_MonthCalendar_respect_ACLs (Thomas Waldmann)
- FIX_XSS_in_AttachFile_do_parameter (Thomas Waldmann)
- CVE-2007-0857

* Thu Feb  8 2007 Paul Howarth <paul@city-fan.org> 1.5.7-1
- Update to 1.5.7

* Mon Dec 11 2006 Paul Howarth <paul@city-fan.org> 1.5.6-2
- Rebuild for python 2.5 on Rawhide

* Mon Oct 30 2006 Paul Howarth <paul@city-fan.org> 1.5.6-1
- Update to 1.5.6

* Mon Sep 18 2006 Paul Howarth <paul@city-fan.org> 1.5.5a-1
- Update to 1.5.5a
- Don't ghost .pyo files

* Mon Jul  3 2006 Paul Howarth <paul@city-fan.org> 1.5.4-1
- Update to 1.5.4
- Include fastcgi subpackage material as documentation in the main package
  since I'm not using it any more, and know of nobody else that is either
- Script the generation of the python files list to clean up the spec

* Mon Apr 17 2006 Paul Howarth <paul@city-fan.org> 1.5.3-1
- Update to 1.5.3
- More new script directories

* Mon Apr 10 2006 Paul Howarth <paul@city-fan.org> 1.5.3-0.rc2.1
- Update to 1.5.3-rc2

* Mon Mar 27 2006 Paul Howarth <paul@city-fan.org> 1.5.3-0.rc1.1
- Update to 1.5.3-rc1
- Patch for http://moinmoin.wikiwikiweb.de/MoinMoinBugs/IncludeMacroBroken no
  longer needed
- Scripts in %%{_bindir} replaced by a single "moin" script wrapper
- Some python modules moved around

* Fri Mar 24 2006 Paul Howarth <paul@city-fan.org> 1.5.2-5
- Use buildsys-macros %%{?dist} tag instead of my proprietary stuff

* Mon Feb 27 2006 Paul Howarth <paul@city-fan.org> 1.5.2-4
- Update SELinux advice in README files

* Fri Feb 24 2006 Paul Howarth <paul@city-fan.org> 1.5.2-3
- Add fastcgi subpackage

* Thu Feb 16 2006 Paul Howarth <paul@city-fan.org> 1.5.2-2
- Add patch for http://moinmoin.wikiwikiweb.de/MoinMoinBugs/IncludeMacroBroken

* Wed Feb  8 2006 Paul Howarth <paul@city-fan.org> 1.5.2-1
- Update to 1.5.2
- Add new directories %%{python_sitelib}/MoinMoin/scripts/{import,packages}
- Update config patch for data directory locations in wikiconfig.py
- Add dependency on words package and make symlink to dictionary for
  use by spellchecker

* Fri Jan 13 2006 Paul Howarth <paul@city-fan.org> 1.5.0-1
- Update to 1.5.0
- Generate sane %%{python_sitelib} macro and use it
- General spec file tidy
- Update config patch (mostly now upstream)
- Some different docs
- Use standard python build and approach
- Add SELinux notes to README-rpm
- Bump python requirement to 2.3
- Clear up lots of rpmlint warnings about non-executable scripts
  (still plenty left though, most of which are I think ignorable)

* Sun Dec 18 2005 Tommy Reynolds <Tommy.Reynolds@MegaCoder.com> 1.3.5-3
- Remove extraneous '\' from XML output, so that <screen>..</screen>
  does not generate '\' 'n' outside of any markup.

* Mon Aug 15 2005 Matthias Saou <http://freshrpms.net/> 1.3.5-2
- Fix python modules path from _libdir to _prefix/lib so that build works on
  64bit systems too.

* Mon Aug 15 2005 Matthias Saou <http://freshrpms.net/> 1.3.5-1
- Update to 1.3.5.
- Update the config patch.
- Update %%doc section (many moved to docs/).

* Wed Jun 15 2005 Matthias Saou <http://freshrpms.net/> 1.3.4-1
- Update to 1.3.4.
- Update the config patch.
- Move the README.redhat file out from the patch and rename it to README-rpm.

* Tue Apr 19 2005 Matthias Saou <http://freshrpms.net/> 1.3.3-2
- Adapted for inclusion into Extras.
- Merge relevant bits from Jeff's pyvault version.

* Wed Dec 22 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- 1.3.1

* Thu Dec 09 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- 1.3.0

* Sun Nov 07 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- 1.3beta4

* Fri Aug 06 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- update to 1.2.3

* Wed May 19 2004 - Kai.Puolamaki@iki.fi
- Fix also directory permissions...

* Mon May 17 2004 - Kai.Puolamaki@iki.fi
- Fix file permissions

* Fri May 14 2004 - Kai.Puolamaki@iki.fi
- 1.2.1
- Home build
